<h1 align="center"> ⭐️ MiDispositivoMIDI V3 ⭐️ </h1>

<p align="center">
  <a href="www.facebook.com/bananutelectronics">
    <img width=50% src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/mdmv3_gif.gif">
  </a>
  
<p align="center">
  Connect our device to your computer and start making music! Totally Plug&Play without any extra software, just your favourite MIDI sequencer (Logic, Ableto, Nuendo). It is not only a great tool for making music and experimenting, you can also use it to learn more about electronics, programming and Arduino. You have tons of code examples ready to load, but if you feel up to it, you can also contribute with your code. And last but not least! It is open source! You can either buy it at our website, our build it yourself, all the schematics and code are available in this repository.
  <p align="center">
  <a href="www.facebook.com/bananutelectronics">
    <img width=50% src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/mdm.jpeg">
  </a>
</p>
</p>

---

<h2 align="center">❤️ Follow us! ❤️</h2>
<p align="center">
  <a href="https://www.facebook.com/bananutelectronics">
<img border="0" src="https://cdn.jsdelivr.net/npm/simple-icons@latest/icons/facebook.svg" width="64" height="64"></a>
  
  <a href="https://www.instagram.com/bananutelectronics">
<img border="0" src="https://cdn.jsdelivr.net/npm/simple-icons@latest/icons/instagram.svg" width="64" height="64"></a>

  <a href="https://github.com/Bananut-Electronics/">
<img border="0" src="https://cdn.jsdelivr.net/npm/simple-icons@latest/icons/github.svg" width="64" height="64"></a>

  <a href="https://www.youtube.com/channel/UCHQbpOPa1lVauoBouRJ16Iw">
<img border="0" src="https://cdn.jsdelivr.net/npm/simple-icons@latest/icons/youtube.svg" width="64" height="64"></a>

  <a href="https://twitter.com/bn_electronics">
<img border="0" src="https://cdn.jsdelivr.net/npm/simple-icons@latest/icons/twitter.svg" width="64" height="64"></a>
</p>

---

<h2 align="center">💶 Want to buy the product? 💶</h2>

<p align="center">
  <a href="https://www.tindie.com/stores/bnelectronics/?ref=offsite_badges&utm_source=sellers_bnelectronics&utm_medium=badges&utm_campaign=badge_medium"><img src="https://d2ss6ovg47m0r5.cloudfront.net/badges/tindie-mediums.png" alt="I sell on Tindie" width="150" height="78"></a>
</p>

---

<h2 align="center">📗 Index 📗</h2>

<p align="center">
  <a href="#about-us">About us</a> •
  <a href="#history">History</a> •
  <a href="#midispositivomidi-v3">MiDispositivoMIDI V3</a> •
  <a href="#expansions">Expansions</a> •
  <a href="#documentation">Documentation</a> •
  <a href="#media">Media</a> •
  <a href="#contributing">Contributing</a> •
  <a href="#license">License</a>
</p>

---

<img align="left" width="100" height="100" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/header_bn.png">

# About us
Hi! We are BanaNut Electronics and we develop software and hardware for Arduino with educational purposes. We were born at the UPM University in Madrid during 2013 and we haven't stopped ever since.

<center>

|      LightWand Kosmonaut V2      |  MiDispositivoMIDI V3 |
|:-------------:|:------:|
|  <img width="160" height="120" src="https://github.com/Bananut-Electronics/LightWand_Kosmonaut_V2/blob/master/01_Documentation/00_Summary/LWK2_Product_1.png"> | <img width="160" height="120" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/touchpads.JPG?raw=true"> |

</center>

---


<img align="left" width="100" height="100" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/header_bn2.png">

# History
Everything started with the first version at the Polytechnical University of Madrid (UPM) in 2013. We were a couple of young students interested in music and electronics, and we came up with this idea. We started reusing some hardware, mainly found at SparkFun's website, but only one year later, we had the second version that was fully designed by us. After some trial and error and feedback from users and friends, we released this third version V3 in 2017. We not only released the code, but also we started producing devices and selling them on the internet, first in our web and later on at Tindie.com store.

During the years, the different versions of MiDispositivoMIDI have been used by many people, engineers, musicians and even kids. We gave some workshops at UPM Madrid for students in Electrical and Telecommunications Engineering, where we gave all the materials and the students had to solder, assembly and code the device.

<p align="center">
<img width="360" height="280" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_VA3C/raw/master/images/MDM_V3_INTRO_Workshop_0.jpg">  <img width="360" height="280" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_VA3C/raw/master/images/MDM_V3_INTROWorkshop_1.jpg">
</a>

---

<img align="left" width="100" height="100" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/header_bn3.png">

# MiDispositivoMIDI V3
We are proud to present the MiDispositivoMIDI V3, which is the latest version we have out in the market (Jan 2019). MiDispositivoMIDI is an open source MIDI controller based on Arduino. In other words, its a small device with tons of LEDs and buttons, that you can connect to your computer to, in example, make music. Our device works with the MIDI protocol, a very well known protocol used in the music industry. You can just plug our device and start using it with your favourite DAW, such as Logic, Ableton or Cubase. No other extra softare is needed.

If you are also interested in programming and electronics, this device offer you a great tool to learn by example. You can also use it to prototype and play around. And also, since it is open source you can fully costumize it to your needs. If you don't know much about coding, just load the codes that we provide, and use them. But if you like coding, you can also publish your code with new features or improvements for others to use.

<p align="center">
<a href="www.facebook.com/bananutelectronics">
    <img width=50% src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/mdm.jpg">
</a>

<p align="center">
<a href="www.facebook.com/bananutelectronics">
    <img width=50% src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/back.jpg">
</a>

These are the features of our device:
* Plug & Play MIDI device.
* Open source based on Arduino.
* Have 16 pad buttons in a 4x4 matrix.
* Have 2 lateral buttons.
* Have RGB leds with 256 levels of intensity of each color.
* Micro USB conection.
* Dimensions of 10x10 cm.
* Modular design. Connect up to 4 devices.
* Fully compatible with Logic, Ableton or Cubase.

<p align="center">
<img width="400" height="225" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/MDM_V3_4By4_GIF.gif">  <img width="350" height="225" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/MDM_V3_4By4_PIC1.jpg">
</a>

---

<img align="left" width="100" height="100" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/header_bn4.png">

# Expansions

Our device has a modular design, which means that with the same hardware, you can keep adding modules to convert it into a bigger controller. For example, if you put four MiDispositivoMIDI V3 into a 8x8 configuration, you will have 64 buttons. All this can be done using the same hardware and with very few modificatons in the code. Note that you can also replace a 4x4 button matrix by a 4x4 potentiometer matrix, but this feature is not implemented yet.

<p align="center">
<a href="www.facebook.com/bananutelectronics">
    <img width=50% src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/configuration.jpg">
</a>

## 4x16 Configuration

You can connect 4 MiDispositivoMIDI V3 in a 4x16 configuration to get the following. With something like this, you can, for example, create an step sequencer. See this video for an example:
* https://www.youtube.com/watch?v=bYyvVDn-gKs

<p align="center">
<img width="400" height="225" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/MDM_V3_4By16_GIF.gif">  <img width="350" height="225" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/MDM_V3_4By16PIC1.jpg">
</a>

## 8x8 Configuration
Same as before, you can connect the devices with a different configuration. Note that the connections are done under the PCB with an extra PCB, so no extra wiring is needed.

<p align="center">
<img width="400" height="255" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/MDM_V3_8By16_GIF.gif">  <img width="350" height="255" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/MDM_V3_8By8_PIC1.jpg">
</a>

## 4x8 Configuration
TODO

---

<img align="left" width="100" height="100" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/header_bn5.png">

# Documentation

We provide a C++ Arduino library that you can use with our device, that simplifies the tasks of handling the LEDs and buttons. The code is self documented, but we have also written a nice Wiki page where you can find more information about the hardware, some hints about MIDI protocol and some low level software examples in Arduino, that will allow you to understand how it works:
* Wiki: https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/wiki

---

<img align="left" width="100" height="100" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/header_bn6.png">

# Media

We invite you to check our YouTube channel, where we post videos about our devices. You can also follow other social networks such as Instagram o Facebook.

* https://www.youtube.com/watch?v=3QnzLwpbpRE&t
* https://www.youtube.com/watch?v=8WFfShg-0Dk
* https://www.youtube.com/watch?v=2y8fhmTmedI
* https://www.youtube.com/watch?v=TsuVpFoLFyI

---

<img align="left" width="100" height="100" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/header_bn7.png">

# Contributing

---

<img align="left" width="100" height="100" src="https://github.com/Bananut-Electronics/MiDispositivoMIDI_V3/blob/master/images/header_bn8.png">

# License

<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc-sa/4.0/88x31.png" /></a><br /><span xmlns:dct="http://purl.org/dc/terms/" property="dct:title">MiDispositivoMIDI</span> by <a xmlns:cc="http://creativecommons.org/ns#" href="www.bananutelectronics.com" property="cc:attributionName" rel="cc:attributionURL">Alvaro Lopez & Pablo de Miguel Morales</a> is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License</a>.<br />
